# Maxima and computer algebra use in STACK

STACK uses the computer algebra system (CAS) [Maxima](Maxima_background.md).  This section of the documentation deals with Maxima-specific functions, including core Maxima and functions defined by STACK.

## Maxima in STACK {#reference}

* [Predicate functions](Predicate_functions.md), which are useful to test expressions.
* [Numbers](Numbers.md), including floating point and complex numbers.
* [Simplification](Simplification.md) can be switched on and off in Maxima.
* [Inequalities](Inequalities.md).
* [Matrices and vectors](Matrix.md).
* [Statistics](Statistics.md).
* [Randomly generated objects](Random.md).
* [Maxima plot2d](Maxima_plot.md).
* [Buggy rules](Buggy_rules.md) implements rules which are not always valid!

## Working offline

We recommend you download and use the graphical desktop interface WxMaxima for working offline, on your desktop.

* Setting up a [STACK-Maxima sandbox](STACK-Maxima_sandbox.md) for testing code on the desktop.
