# STACK

STACKは，数学，科学，および関連分野のための，世界をリードするオープンソース（GPL）の数式自動採点システムで，以下の特徴があります．

* 学生は数式を入力し，多肢選択式に制限されることはありません．
* 形成的評価に重点を置いた，__確認__ と __評価__ の分離．
* ランダムな問題生成．
* 行単位での評価を含む，多様な入力タイプ．
* マルチパート問題のサポート．
* SI単位と有効数字のサポート．

これはSTACKの公式ユーザードキュメントです．

* STACKのメインのコミュニティサイト： [https://stack-assessment.org/](https://stack-assessment.org/)
* ドキュメントサーバ（エディンバラ大学）： [https://stack-demo.maths.ed.ac.uk/demo/](https://stack-demo.maths.ed.ac.uk/demo/)
* コミュニティの議論： [https://stack-assessment.zulipchat.com/](https://stack-assessment.zulipchat.com/)

#### [**問題作成**](../en/Authoring/index.md)

問題作成のドキュメントには以下のものが含まれています：

* [問題作成クイック・スタート・ガイド](AbInitio/index.md)："STACKこと始め" [ガイド](../content/2019-STACK-Guide.pdf)と一緒に利用できます．
* 様々な[問題作成トピック](../en/Authoring/index.md)に関する情報:[評価関数](../en/Authoring/Answer_Tests/index.md), [入力](../en/Authoring/Inputs.md), [ポテンシャル・レスポンス・ツリー](../en/Authoring/Potential_response_trees.md)，[翻訳](../en/Authoring/Languages.md).
* [FAQ](../en/Authoring/Author_FAQ.md).
* [数式処理システムMaxima](../en/CAS/index.md)に関する情報：[ランダム化](../en/CAS/Random.md), [グラフ作成](../en/Plots/index.md), [数式簡略化](../en/CAS/Simplification.md)．

#### [**学生向け情報**](../en/Students/index.md)

STACKを利用する学生向け情報：

* [数式入力](../en/Students/Answer_input.md).
* [解答の評価](../en/Students/Answer_assessment.md).
* [FAQ](../en/Students/FAQ.md).

#### [**インストール**](../en/Installation/index.md)

* [インストール方法](../en/Installation/index.md).

#### **[開発者向け情報](../en/Developer/index.md)**

開発者向けのトピック：

* [開発の歴史](../en/Developer/Development_history.md).
* [STACKの翻訳](../en/Developer/Language_packs.md).
* [入力タイプの開発](../en/Developer/Creating_an_input_type.md).
